#ifndef _OrxoBloxScore_H__
#define _OrxoBloxScore_H__

#include "OrxoBlox/OrxoBloxPrereqs.h"

#include "tools/interfaces/Tickable.h"

#include "overlays/OverlayText.h"

namespace orxonox
{

    /**
    @brief
        The OrxoBloxScore class displays the score for a game of @ref orxonox::OrxoBlox "OrxoBlox".

    @author
        Fabian 'x3n' Landau

    @ingroup OrxoBlox
    */
    class _OrxoBloxExport OrxoBloxScore : public OverlayText, public Tickable
    {
        public:
            OrxoBloxScore(Context* context);
            virtual ~OrxoBloxScore();

            virtual void tick(float dt) override; //!< Creates and sets the caption to be displayed by the OrxoBloxScore.
            virtual void changedOwner() override; //!< Is called when the owner changes.


        private:
            OrxoBlox* owner_; //!< The OrxoBlox game that owns this OrxoBloxScore.
            PlayerInfo* player_; //!< Store information about the player permanently.
    };
}
#endif /* _OrxoBloxScore_H__ */
