#ifndef _OrxoBloxShip_H__
#define _OrxoBloxShip_H__


#include "OrxoBloxPrereqs.h"

#include "worldentities/pawns/SpaceShip.h"
#include "tools/Timer.h"

namespace orxonox
{
    class _OrxoBloxExport OrxoBloxShip : public SpaceShip
    {
        public:
            OrxoBloxShip(Context* context);

            virtual void tick(float dt) override;

            //no rotation in x and z direction!
            //virtual void rotatePitch(const Vector2& value) override{}; // Rotate in pitch direction.
            //Yaw
            virtual void rotatePitch(const Vector2& value) override{}; // Rotate in pitch direction.
            virtual void rotateRoll(const Vector2& value) override{}; // Rotate in roll direction.
            virtual void boost(bool boost) override; //Override, so that the ship does not shake
            
            
            /*Functions that can be helpful while debugging.
                - Set a timer so that the function is called for instance every 3s to display the coordinates
                - Open console with "~`"-key in when you start the Asteroids2D - Minigame.
            */
            void showposition();
            void showorientation();


            void toggleImmune()
            {
                bImmune = !bImmune;
            }

        //protected:
        private:
            OrxoBlox* getGame();

            float width, height;
            WeakPtr<OrxoBlox> game;
            bool bImmune;
            Timer timer;
            Timer isimmune;
    };
}

#endif /* _Asteroids2DShip_H__ */
