#ifndef _OrxoBloxStones_H__
#define _OrxoBloxStones_H__


#include "OrxoBlox/OrxoBloxPrereqs.h"


#include "worldentities/StaticEntity.h"
#include "worldentities/pawns/Pawn.h"
#include "tools/Timer.h"

namespace orxonox
{

    /**
    @brief

    @author

    @ingroup OrxoBlox
    */
    class _OrxoBloxExport OrxoBloxStones : public Pawn
    {
        public:
            OrxoBloxStones(Context* context); //!< Constructor. Registers and initializes the object.
            virtual ~OrxoBloxStones() {}
             //   this.destroy();
            //}

            /**
            @brief Set the size of the stone.
            @param size The dimensions a stone has in the game world. (A stone is a cube)
            */
            void setSize(float size)
                { this->size_ = size; }
            /**
            @brief Get the size of the stone.
            @return Returns the dimensions a stone has in the game world. (A stone is a cube)
            */
            float getSize(void) const
                { return this->size_; }
            
            void gotHit(){
                orxout()<<"GOT HIT"<<endl;
                unsigned int health_ =this->getHealth();
                if (health_> 0){
                    this->setHealth(++health_); 
                    }
                else {
                    this->kill();
                }
                }

            void setGame(OrxoBlox* orxoblox)
                { assert(orxoblox); orxoblox_ = orxoblox; }

            unsigned int getHealth();

            void reduceHealth();

            float getSize();
            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;
                
        private:
            float size_; //!< The dimensions a stone has in the game world.
            bool delay_;
            
            OrxoBlox* orxoblox_;
            

    };
}

#endif /* _OrxoBloxStones_H__ */
